---
title: Firefox 60 for developers
slug: Mozilla/Firefox/Releases/60
tags:
  - '60'
  - Firefox
  - Release Notes
---
<div>{{FirefoxSidebar}}</div>

<p class="summary">This article provides information about the changes in Firefox 60 that will affect developers. Firefox 60 was released on May 9, 2018.</p>

<h2 id="Stylo_comes_to_Firefox_for_Android_in_60">Stylo comes to Firefox for Android in 60</h2>

<p><a href="https://hacks.mozilla.org/2017/08/inside-a-super-fast-css-engine-quantum-css-aka-stylo/">Firefox's new parallel CSS engine</a> — also known as <strong>Quantum CSS</strong> or <strong>Stylo</strong> — which was <a href="/en-US/Firefox/Releases/57#Firefox_57_Firefox_Quantum">first enabled by default in Firefox 57 for desktop</a>, has now been enabled in Firefox for Android.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<ul>
 <li>In the CSS Pane rules view (see <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS">Examine and edit CSS</a>), the keyboard shortcuts for precise value increments (increase/decrease by 0.1) have changed from <kbd>Alt</kbd> + <kbd>Up</kbd>/<kbd>Down</kbd> to <kbd>Ctrl</kbd> + <kbd>Up</kbd>/<kbd>Down</kbd> on Linux and Windows, to avoid clashes with default OS-level shortcuts (see {{bug("1413314")}}).</li>
 <li>Also in the CSS Pane rules view, <a href="/en-US/docs/Web/CSS/Using_CSS_variables">CSS variable names</a> will now auto-complete ({{bug(1422635)}}). If you enter <code>var(</code> into a property value and then type a dash (<code>-</code>), any variables you have declared in your CSS will then appear in an autocomplete list.</li>
 <li>In <a href="/en-US/docs/Tools/Responsive_Design_Mode">Responsive Design Mode</a>, a <em>Reload when...</em> dropdown has been added to allow users to enable/disable automatic page reloads when touch simulation is toggled, or simulated user agent is changed. See <a href="/en-US/docs/Tools/Responsive_Design_Mode#Controlling_page_reload_behavior">Controlling page reload behavior</a> for more details ({{bug(1428816)}}).</li>
 <li>The <code>view_source.tab</code> preference has been removed so you can no longer toggle <a href="/en-US/docs/Tools/View_source">View Source</a> mode between appearing in a new tab or new window. Page sources will always appear in new tabs from now on ({{bug(1418403)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<p>Pressing the Enter key in <code>designMode</code> and <code>contenteditable</code> now inserts <code>&lt;div&gt;</code> elements when the caret is in an inline element or text node which is a child of a block level editing host — instead of inserting <code>&lt;br&gt;</code> elements like it used to. If you want to use the old behavior on your app, you can do it with <code>document.execCommand()</code>. See <a href="/en-US/docs/Web/Guide/HTML/Editable_content#Differences_in_markup_generation">Differences in markup generation</a> for more details (also see {{bug(1430551)}}).</p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The {{cssxref("align-content")}}, {{cssxref("align-items")}}, {{cssxref("align-self")}}, {{cssxref("justify-content")}}, and {{cssxref("place-content")}} property values have been updated as per the latest <a href="https://drafts.csswg.org/css-align-3/">CSS Box Alignment Module Level 3</a> spec ({{bug(1430817)}}).</li>
 <li>The {{cssxref("paint-order")}} property has been implemented ({{bug(1426146)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No changes.</em></p>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>ECMAScript 2015 modules have been enabled by default in ({{bug(1438139)}}). See <a href="https://hacks.mozilla.org/2015/08/es6-in-depth-modules/">ES6 In Depth: Modules</a> and <a href="https://hacks.mozilla.org/2018/03/es-modules-a-cartoon-deep-dive/">ES modules: A cartoon deep dive</a> for more information, or consult MDN reference docs:

  <ul>
   <li><a href="/en-US/docs/Web/HTML/Element/script#attr-type"><code>&lt;script src="main.js" type="module"&gt;</code></a> and <a href="/en-US/docs/Web/HTML/Element/script#attr-nomodule"><code>&lt;script nomodule src="fallback.js"&gt;</code> </a></li>
   <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/import">import</a></code> and <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/export">export</a></code> statements.</li>
  </ul>
 </li>
 <li>The {{jsxref("Array.prototype.values()")}} method has been added again ({{bug(1420101)}}). It was disabled due to <a href="https://www.fxsitecompat.com/en-CA/docs/2016/array-prototype-values-breaks-some-legacy-apps/">compatibilty issues</a> in earlier versions. Make sure your code doesn't have any custom implementation of this method.</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="New_APIs">New APIs</h4>

<ul>
 <li>The <a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a> has been enabled in ({{bug(1432542)}}).</li>
</ul>

<h4 id="DOM">DOM</h4>

<ul>
 <li>In the <a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a>, the <code>MakePublicKeyCredentialOptions</code> dictionary object has been renamed {{domxref("PublicKeyCredentialCreationOptions")}}; this change has been made in Firefox ({{bug(1436473)}}).</li>
 <li>The <code>dom.workers.enabled</code> pref has been removed, meaning workers can no longer be disabled since ({{bug(1434934)}}).</li>
 <li>The {{domxref("Document.body","body")}} property is now implemented on the {{domxref("Document")}} interface, rather than the {{domxref("HTMLDocument")}} interface ({{bug(1276438)}}).</li>
 <li>{{domxref("PerformanceResourceTiming")}} is now available in workers ({{bug(1425458)}}).</li>
 <li>The {{domxref("PerformanceObserver.takeRecords()")}} method has been implemented ({{bug(1436692)}}).</li>
 <li>The {{domxref("KeyboardEvent.keyCode")}} attribute of punctuation key becomes non-zero even if the active keyboard layout doesn't produce ASCII characters. See <a href="/en-US/docs/Web/API/KeyboardEvent/keyCode#keyCode_of_punctuation_keys_on_some_keyboard_layout">these notes for more detail</a>. Please do <strong>not</strong> use <code>KeyboardEvent.keyCode</code> in new applications — use {{domxref("KeyboardEvent.key")}} or {{domxref("KeyboardEvent.code")}} instead.</li>
 <li>The {{domxref("Animation.updatePlaybackRate()")}} method has been implemented ({{bug("1436659")}}).</li>
 <li>New rules have been included for determining <a href="/en-US/docs/Web/API/KeyboardEvent/keyCode#keyCode_of_punctuation_keys_on_some_keyboard_layout">keyCode values of punctuation keys</a> ({{bug(1036008)}}).</li>
 <li>The Gecko-only options object <code>storage</code> option of the {{domxref("IDBFactory.open()")}} method (see <a href="/en-US/docs/Web/API/IDBFactory/open#Experimental_Gecko_options_object">Experimental Gecko options object</a>) has been deprecated ({{bug(1442560)}}).</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">Promises</a> can now be used within <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a> code ({{bug(1193394)}}).</li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<p><em>No changes.</em></p>

<h4 id="Service_workers">Service workers</h4>

<p><em>No changes.</em></p>

<h4 id="Media_and_WebRTC">Media and WebRTC</h4>

<ul>
 <li>When recording or sharing media obtained using {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}, muting the camera by setting the corresponding track's {{domxref("MediaStreamTrack.enabled")}} property to <code>false</code> now turns off the camera's "in use" indicator light, to help the user more easily see that the camera is not in use ({{bug(1299515)}}). See {{SectionOnPage("/en-US/docs/Web/API/MediaDevices/getUserMedia", "User privacy")}} for more details. See also <a href="https://blog.mozilla.org/webrtc/better-privacy-on-camera-mute-in-firefox-60/">this blog post</a>.</li>
 <li>Removing a track from an {{domxref("RTCPeerConnection")}} using {{domxref("RTCPeerConnection.removeTrack", "removeTrack()")}} no longer removes the track's {{domxref("RTCRtpSender")}} from the peer connection's list of senders as reported by {{domxref("RTCPeerConnection.getSenders", "getSenders()")}} ({{bug(1290949)}}).</li>
 <li>The {{domxref("RTCRtpContributingSource")}} and {{domxref("RTCRtpSynchronizationSource")}} objects' timestamps were previously being reported based on values returned by {{jsxref("Date.getTime()")}}. In Firefox 60, these have been fixed to correctly use the <a href="/en-US/docs/Web/API/Performance_API">Performance Timing API</a> instead ({{bug(1433576)}}).</li>
 <li>As per spec, the {{domxref("ConvolverNode.ConvolverNode","ConvolverNode()")}} constructor now throws a <code>NotSupportedError</code> if the referenced {{domxref("AudioBuffer")}} does not have 1, 2, or 4 channels ({{bug(1443228)}}).</li>
 <li>The obsolete {{domxref("RTCPeerConnection")}} event handler {{domxref("RTCPeerConnection.onremovestream")}} has been removed; by now you should be using {{event("removetrack")}} events instead ({{bug(1442385)}}).</li>
 <li>The primary name for {{domxref("RTCDataChannel")}} is now in fact <code>RTCDataChannel</code>, instead of being an alias for <code>DataChannel</code>. The name <code>DataChannel</code> is no longer supported ({{bug(1173851)}}).</li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<ul>
 <li>If the <code>privacy.resistFingerprinting</code> preference is set to <code>true</code>, the {{domxref("WEBGL_debug_renderer_info")}} WebGL extension will be disabled from now on ({{bug(1337157)}}).</li>
</ul>

<h3 id="CSSOM">CSSOM</h3>

<p><em>No changes.</em></p>

<h3 id="HTTP">HTTP</h3>

<ul>
 <li><code>SameSite</code> cookies are now supported ({{bug(795346)}}). See {{HTTPHeader("Set-Cookie")}} for more information.</li>
</ul>

<h3 id="Security">Security</h3>

<p>The {{httpheader("X-Content-Type-Options")}} header, when set to <code>no-sniff</code>, now follows the specification for JavaScript MIME types. In particular, <code>text/json</code> and <code>application/json</code> are no longer valid values ({{bug(1431095)}}).</p>

<h3 id="Plugins">Plugins</h3>

<p><em>No changes.</em></p>

<h3 id="Other">Other</h3>

<p>Fetches that include credentials can now share connections with fetches that don't include credentials. For example, if the same origin requests some web fonts as well as some credentialed user data from the same CDN, both could share a connection, potentially leading to a quicker turnaround ({{bug(1363284)}}).</p>

<h2 id="Removals_from_the_web_platform">Removals from the web platform</h2>

<h3 id="HTML_2">HTML</h3>

<p><em>No changes.</em></p>

<h3 id="CSS_2">CSS</h3>

<ul>
 <li>The proprietary {{cssxref("-moz-user-input")}} property's <code>enabled</code> and <code>disabled</code> values are no longer available ({{bug("1405087")}}).</li>
 <li>The proprietary {{cssxref("-moz-border-top-colors")}}, {{cssxref("-moz-border-right-colors")}}, {{cssxref("-moz-border-bottom-colors")}}, and {{cssxref("-moz-border-left-colors")}} properties have been removed from the platform completely ({{bug(1429723)}}).</li>
</ul>

<h3 id="JavaScript_2">JavaScript</h3>

<p>The non-standard <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Expression_closures">expression closure</a> syntax has been removed ({{bug(1426519)}}).</p>

<h3 id="APIs_2">APIs</h3>

<p><em>No changes.</em></p>

<h3 id="SVG_2">SVG</h3>

<p><em>No changes.</em></p>

<h3 id="Other_2">Other</h3>

<p><em>No changes.</em></p>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="WebExtensions">WebExtensions</h3>

<p>Theme API:</p>

<ul>
 <li>headerURL is now optional</li>
 <li>When creating a browser <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/theme">theme</a>, any {{cssxref("text-shadow")}} applied to the header text is removed if no <code>headerURL</code> is specified (see {{bug(1404688)}}).</li>
 <li>New properties are supported:
  <ul>
   <li><strong>tab_line</strong></li>
   <li><strong>tab_selected</strong></li>
   <li><strong>popup</strong></li>
   <li><strong>popup_border</strong></li>
   <li><strong>popup_text</strong></li>
   <li><strong>tab_loading</strong></li>
   <li><strong>icons</strong></li>
   <li><strong>icons_attention</strong></li>
   <li><strong>frame_inactive</strong></li>
   <li><strong>button_background_active</strong></li>
   <li><strong>button_background_hover</strong></li>
  </ul>
 </li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/60">Site Compatibility for Firefox 60</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(59)}}</p>
